////////////////////////////////////////////////////////////////////////////////
//  TXiCamVVRK1   -  
// 
////////////////////////////////////////////////////////////////////////////////

//---------------------------------------------------------------------------


#pragma hdrstop

#include "XiCamVVRK1.h"

//---------------------------------------------------------------------------

#pragma package(smart_init)


namespace Xi {
//--------- namespace Xi { -----------------------------------------------------

////////////////////////////////////////////////////////////////////////////////
//  TXiCamVVRK1Connection --   
////////////////////////////////////////////////////////////////////////////////
//------------------------------------------------------------------------------
//   
//------------------------------------------------------------------------------
__fastcall TXiCamVVRK1Connection::TXiCamVVRK1Connection()
{
   FCamera = NULL;      //   
}


//------------------------------------------------------------------------------
//    ,     ,    
//------------------------------------------------------------------------------
__fastcall TXiCamVVRK1Connection::~TXiCamVVRK1Connection()
{
   if(FCamera)
      FCamera->FConnection = NULL;  //     
                                    //    
}


//------------------------------------------------------------------------------
//    ,     -
//   (  )
//------------------------------------------------------------------------------
void TXiCamVVRK1Connection::InitCam()
{
   if(FCamera)
      FCamera->InitCam();   //  
}

//------------------------------------------------------------------------------
// .  Active
//------------------------------------------------------------------------------
void __fastcall TXiCamVVRK1Connection::SetActive(bool value)
{
}


////////////////////////////////////////////////////////////////////////////////
//  TXiCamVVRK1_CnctnCOM --   COM-
////////////////////////////////////////////////////////////////////////////////
//------------------------------------------------------------------------------
//    AdcComPort
//------------------------------------------------------------------------------
__fastcall
   TXiCamVVRK1_CnctnCOM::TXiCamVVRK1_CnctnCOM(TApdCustomComPort* tAdpComPort):
      TXiCamVVRK1Connection()
{
   FActive = false;                 //  
   F_ApdComPort = NULL;             //   --
   AdpComPort = tAdpComPort;        //SetApdComPort(F_ApdComPort);

   GettingShotData = false;         //     
   FShotEndTrig = NULL;             //    --  
   FShotGettingTimeout = NULL;      //    --   
}

//------------------------------------------------------------------------------
// 
//------------------------------------------------------------------------------
__fastcall TXiCamVVRK1_CnctnCOM::~TXiCamVVRK1_CnctnCOM()
{

}

//------------------------------------------------------------------------------
//      COM- ( TurboPower)
//------------------------------------------------------------------------------
void __fastcall TXiCamVVRK1_CnctnCOM::SetApdComPort(TApdCustomComPort* tAdpComPort)
{
   F_ApdComPort = tAdpComPort;      // .    --

   //         tAdpComPort
   F_ApdComPort->AutoOpen = false;  //  
}


//------------------------------------------------------------------------------
// -     
//------------------------------------------------------------------------------
ERRCODE __fastcall TXiCamVVRK1_CnctnCOM::Set_n_Get(void* OutBuf, UDWORD OutCnt,
   void* InBuf, UDWORD InCnt)
{
   UDWORD wBytes = 0;            //  /
   TRWError FunRes = rweNone;    //  

  //   , ...
   if(!F_ApdComPort)
      return rweNone;
   else
      if(!F_ApdComPort->Open)
         return rweNone;

   if(OutBuf)  //   
   {
      if(UDWORD(F_ApdComPort->OutBuffFree) >= OutCnt)
         F_ApdComPort->PutBlock(OutBuf, OutCnt);      //  
      else
         FunRes |= TXiCamVVRK1Connection::rweWrite;   //  
   } // if(OutBuf)  //   

   Sleep(100);     // TODO:   100 
   if(Camera->OnResponseWait)
      Camera->OnResponseWait(Camera);    // -  


   if(InBuf)      //  
   {

      if(F_ApdComPort->CharReady())
      {
         wBytes = F_ApdComPort->InBuffUsed;     //    . 
         if(wBytes && (wBytes == InCnt) )
            F_ApdComPort->GetBlock(InBuf, wBytes); // ,   
         else
            FunRes |= TXiCamVVRK1Connection::rweRead; //  
      }
      
   } // if(InBuf)      //  


   return FunRes;
}


//------------------------------------------------------------------------------
// -   ,  ,  
//------------------------------------------------------------------------------
__int64 __fastcall TXiCamVVRK1_CnctnCOM::SaveToStream(TStream* tStr, __int64 Count)
{
  //   , ...
   if(!F_ApdComPort)
      return rweNone;
   else
      if(!F_ApdComPort->Open)
         return rweNone;

   UDWORD TotalBytes = 0, BufLen = 0;  //     

   UBYTE* LocalBuf = new UBYTE[Count]; //   
   UBYTE* CurBufPos = LocalBuf;        //    

   GettingShotData = true;       //     


   try
   {

      DWORD TimeStart = GetTickCount();   //  ...

      while(Count)
      {
         BufLen = F_ApdComPort->InBuffUsed;  //   
         if(BufLen > Count)                  //  ,  
            throw("Buffer overflow.");       // 

         if(BufLen)                          // ,  
         {
            F_ApdComPort->GetBlock(CurBufPos, BufLen);
            Count -= BufLen;           //      
            CurBufPos += BufLen;       //   

           //    ...     .  !
            if(*(CurBufPos - 3) == 0xFF)     // 
               if(*(CurBufPos - 2) == 0xD9)  //  
               {
                  --CurBufPos;         //   
                  Count = 0;           //     
               }

            TimeStart = GetTickCount();   //  
         }
         else
         {  //   . ,   
            if(GetTickCount() - TimeStart >= 5000) // 5 . 
            {
               Count = 0;                 //   
            }
         } // if(BufLen)

         if(Camera->OnResponseWait)
            Camera->OnResponseWait(Camera);    // -  

      } // while(Count)

      TotalBytes = CurBufPos - LocalBuf;  //  

     //     
      if(TotalBytes)
         tStr->WriteBuffer(LocalBuf, TotalBytes);           // ,  

   } // try
   __finally   //      
   {
      delete [] LocalBuf;                //   

   } // __finally

   return TotalBytes;               //    

}


//------------------------------------------------------------------------------
// .  Active
//------------------------------------------------------------------------------
void __fastcall TXiCamVVRK1_CnctnCOM::SetActive(bool value)
{
   if(value == GetActive() || !FCamera)    //   ,   
      return;

   F_ApdComPort->Open = value;            // / --

}

//------------------------------------------------------------------------------
//   Active
//------------------------------------------------------------------------------
bool __fastcall TXiCamVVRK1_CnctnCOM::GetActive()
{
   if(!F_ApdComPort)                
      return false;
   return F_ApdComPort->Open;
}




////////////////////////////////////////////////////////////////////////////////
//  TXiCamVVRK1                                                      //
////////////////////////////////////////////////////////////////////////////////

//------------------------------------------------------------------------------
//    
//------------------------------------------------------------------------------
//const UBYTE* TXiCamVVRK1::WriteRegCmd = "asd";

//------------------------------------------------------------------------------
//   
//------------------------------------------------------------------------------
__fastcall TXiCamVVRK1::TXiCamVVRK1()//:WriteRegCmd("\x3F")
{

   FConnection = NULL;     //   

  //  

   FStateReg.Byte  = 0x02; //     .  2
   FSPICtrl = spic_0e01;   //  SPI: 0 .,   +
   FBrightness = 0x40;     //  
   FLevelR = FLevelG = FLevelB = 0x7C; //  
  //
   FSizeH = 352;           // .   
   FSizeV = 288;           // . 

   FUART = 0x2;            // .  2400

   FTestMode = false;      //   

  //   
   FFrameMade = false;     //    =  

   FSleepTime = 200;       //     = 200  

   FOnCapture = NULL;      //     .
   OnResponseWait = NULL;  //     

}

//------------------------------------------------------------------------------
//  
//------------------------------------------------------------------------------
__fastcall TXiCamVVRK1::~TXiCamVVRK1()
{
  //    ,     () , 
  //  ,       
   Connection = NULL;   // . ,     

}

//------------------------------------------------------------------------------
//   (     )
//------------------------------------------------------------------------------
void __fastcall TXiCamVVRK1::InitCam()
{
  //---  
  //  
   SetRegister(rgnState, FStateReg.Byte);  //  ( ) . .
   Registers[rgnSPICtrl] = UBYTE(FSPICtrl);  // . SPI
   Registers[rgnBrigns] = FBrightness;       // . 

   Registers[rgnLevelR] = FLevelR;
   Registers[rgnLevelG] = FLevelG;
   Registers[rgnLevelB] = FLevelB;

   Registers[rgnUART] = FUART;

   SetRegister2(rgnSizeH, FSizeH);           //  
   DoResponseWait(FSizeDelay);               //  60 ,  

   SetRegister2(rgnSizeV, FSizeV);
   DoResponseWait(FSizeDelay);


   if(FTestMode)                 //     
      ExCommand(cmdTestModeOn);
   else
      ExCommand(cmdTestModeOff);

}

//------------------------------------------------------------------------------
//      
//------------------------------------------------------------------------------
void __fastcall TXiCamVVRK1::LoadCamState()
{
  //      ( -  )
   FStateReg.Byte = Registers[rgnState];                // 
   FSPICtrl = TSPIctrls(GetRegister(rgnSPICtrl));  // . SPI

   FBrightness = GetRegister(rgnBrigns);

   FLevelR = GetRegister(rgnLevelR);
   FLevelG = GetRegister(rgnLevelG);
   FLevelB = GetRegister(rgnLevelB);

   FUART = GetRegister(rgnUART);

   FSizeH = GetRegister2(rgnSizeH);
   FSizeV = GetRegister2(rgnSizeV);
}


//------------------------------------------------------------------------------
// .   ()
//     ,   
//------------------------------------------------------------------------------
void __fastcall TXiCamVVRK1::SetRegister(TRegister tReg, UBYTE value)
{
   UBYTE RegCmdData[2];                      //   
   RegCmdData[0] = TRegsCmds::GetWriteCmd(tReg);    //   
   RegCmdData[1] = value;

   ERRCODE rest = Connection->Set_n_Get(RegCmdData, 2, NULL, 0);  //  +  
   if(rest)    //   ,   
      throw Exception("   ");

}


//------------------------------------------------------------------------------
// .   ()
//------------------------------------------------------------------------------
UBYTE __fastcall TXiCamVVRK1::GetRegister(TRegister tReg)
{
   UBYTE RegCmdData = TRegsCmds::GetReadCmd(tReg); //   
   Connection->Set_n_Get(&RegCmdData, 1, &RegCmdData, 1); //    
   return RegCmdData;   //  
}

//------------------------------------------------------------------------------
// .   (2-)
//------------------------------------------------------------------------------
void __fastcall TXiCamVVRK1::SetRegister2(TRegister tReg, UWORD value)
{
   UBYTE RegCmdData[3];                      //   
   RegCmdData[0] = TRegsCmds::GetWriteCmd(tReg);    //   
   RegCmdData[1] = value >> 8;               // .   
   RegCmdData[2] = (value & 0xFF);           // . 

   ERRCODE rest = Connection->Set_n_Get(RegCmdData, 3, NULL, 0);  //  +  
   if(rest)    //   ,   
      throw Exception("    ");

}

//------------------------------------------------------------------------------
// .   ()
//------------------------------------------------------------------------------
UWORD __fastcall TXiCamVVRK1::GetRegister2(TRegister tReg)
{
   UBYTE RegCmd = TRegsCmds::GetReadCmd(tReg); //   
   UWORD RegData = 0;

   Connection->Set_n_Get(&RegCmd, 1, &RegData, 2); //    

  //   .  .   
   asm {

     mov ax, RegData
     xchg al, ah
     mov RegData, ax
   }  // asm

   return RegData;   //  
   //  ,      AX,  
   //     ,  ... .., ,  ...
}

//------------------------------------------------------------------------------
//    TCommand tCmd
//------------------------------------------------------------------------------
void __fastcall TXiCamVVRK1::ExCommand(TCommand tCmd)
{
   Connection->Set_n_Get(&UBYTE(tCmd), 1, NULL, 0); //  
}


//------------------------------------------------------------------------------
// .   
//------------------------------------------------------------------------------
void __fastcall TXiCamVVRK1::SetColoured(bool value)
{
   value = !value;                  // ..  =  /,  value -- 

  //       
   if(FStateReg.Bits.Coloured == value)
      return;

   FStateReg.Bits.Coloured = value;
   Registers[rgnState] = FStateReg.Byte;

}

//------------------------------------------------------------------------------
// .   
//  ,   
//------------------------------------------------------------------------------
bool __fastcall TXiCamVVRK1::GetColoured() const
{
   return !FStateReg.Bits.Coloured;
}

//------------------------------------------------------------------------------
//    
//------------------------------------------------------------------------------
void __fastcall TXiCamVVRK1::SetAspectRatio(unsigned char value)
{
  //    
   if(value == FStateReg.Bits.AspectRatio)
      return;

   FStateReg.Bits.AspectRatio = value;

   Registers[rgnState] = FStateReg.Byte; //   
}

//------------------------------------------------------------------------------
//    
//------------------------------------------------------------------------------
unsigned char __fastcall TXiCamVVRK1::GetAspectRatio() const
{
   return FStateReg.Bits.AspectRatio;
}

//------------------------------------------------------------------------------
// .    SPI
//------------------------------------------------------------------------------
void __fastcall TXiCamVVRK1::SetSPICtrl(TSPIctrls value)
{
   if(value == FSPICtrl)
      FSPICtrl = value;
   Registers[rgnSPICtrl] = UBYTE(FSPICtrl);
}

//------------------------------------------------------------------------------
// .   
//------------------------------------------------------------------------------
void __fastcall TXiCamVVRK1::SetBrightness(UBYTE value)
{
   if(value == FBrightness)
      return;
      
   FBrightness = value;
   Registers[rgnBrigns] = FBrightness;
}

//------------------------------------------------------------------------------
// .   
//------------------------------------------------------------------------------
void __fastcall TXiCamVVRK1::SetLevelR(UBYTE value)
{
   if(value == FLevelR)
      return;

   FLevelR = value;
   Registers[rgnLevelR] = FLevelR;
}

//------------------------------------------------------------------------------
// .   
//------------------------------------------------------------------------------
void __fastcall TXiCamVVRK1::SetLevelG(UBYTE value)
{
   if(value == FLevelG)
      return;

   FLevelG = value;
   Registers[rgnLevelG] = FLevelG;
}

//------------------------------------------------------------------------------
// .   
//------------------------------------------------------------------------------
void __fastcall TXiCamVVRK1::SetLevelB(UBYTE value)
{
   if(value == FLevelB)
      return;

   FLevelB = value;
   Registers[rgnLevelB] = FLevelB;
}

//------------------------------------------------------------------------------
// . -  UART
//------------------------------------------------------------------------------
void __fastcall TXiCamVVRK1::SetUART(UBYTE value)
{
   if(value == FUART || value > 0xF)
      return;

   FUART = value;
   Registers[rgnUART] = FUART;
}



//------------------------------------------------------------------------------
// .    
//------------------------------------------------------------------------------
void __fastcall TXiCamVVRK1::SetSizeH(UWORD value)
{
   if(value == FSizeH)
      return;

  // ..     ,   
   value = (value >> 4);            //   16
   value = (value << 4);            //   16 (.   )

   FSizeH = value;

   SetRegister2(rgnSizeH, FSizeH);  //  -  2 
   DoResponseWait(FSizeDelay);      // ,  
}

//------------------------------------------------------------------------------
// .    
//------------------------------------------------------------------------------
void __fastcall TXiCamVVRK1::SetSizeV(UWORD value)
{
   if(value == FSizeV)
      return;

  // ..     ,   
   value = (value >> 4);            //   16
   value = (value << 4);            //   16 (.   )

   FSizeV = value;
   SetRegister2(rgnSizeV, FSizeV);  //  -  2 
   DoResponseWait(FSizeDelay);      // ,  
}

//------------------------------------------------------------------------------
// .    (())
//------------------------------------------------------------------------------
void __fastcall TXiCamVVRK1::SetTestMode(bool value)
{
   if(value == FTestMode)
      return;
   FTestMode = value;

   if(FTestMode)                 //    
      ExCommand(cmdTestModeOn);
   else
      ExCommand(cmdTestModeOff);
}



//------------------------------------------------------------------------------
// .  
//------------------------------------------------------------------------------
void __fastcall TXiCamVVRK1::SetConnection(TXiCamVVRK1Connection* value)
{
   if(value == FConnection)
      return;              //   ,   

  //      ,     (NULL)
   if(FConnection)         //    
   {
      FConnection->Active = false;     //   
      FConnection->FCamera = NULL;     //      
   }

  //     ,     
   FConnection = value;

   if(FConnection)         //      
      FConnection->FCamera = this;     //       :)
     //   Active ??
}

//------------------------------------------------------------------------------
// .     
//------------------------------------------------------------------------------
void __fastcall TXiCamVVRK1::SetSleepTime(DWORD value)
{
   if(value == FSleepTime)
      return;
   FSleepTime = value;
}


//------------------------------------------------------------------------------
//      ,      
//  ( ,   2 )
//------------------------------------------------------------------------------
void __fastcall TXiCamVVRK1::ResetCam()
{
   ExCommand(cmdResetCam);    //  
   LoadCamState();            //    
   FFrameMade = false;        //   
}

//------------------------------------------------------------------------------
//           
//  tStr
//------------------------------------------------------------------------------
void __fastcall TXiCamVVRK1::Capture(TStream* tStr)
{
  //  
   ExCommand(cmdCapture);        //  
   DoResponseWait(FSleepTime);   //   

   ExCommand(cmdLoadSnap);    //   

  //   -- 100 ...   ...
   __int64 BytesWrote = Connection->SaveToStream(tStr, 65535);
   if(FOnCapture)
      FOnCapture(this, BytesWrote);    // -  

}

//------------------------------------------------------------------------------
//       
//------------------------------------------------------------------------------
void __fastcall TXiCamVVRK1::DoResponseWait(DWORD tTime)// const
{
   DWORD TimeStart = GetTickCount();
   do {
      if(FOnResponseWait)
         FOnResponseWait(this);              //  
   } while (GetTickCount() - TimeStart < tTime);   // FSleepTime 

}

//--------- } namespace Xi -----------------------------------------------------
}; // namespace Xi {

