//---------------------------------------------------------------------------

#include <vcl.h>
//#include <jpeg.hpp>
#pragma hdrstop

#include "main.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
//#pragma link "AdStatLt"
//#pragma link "OoMisc"
//#pragma link "AdPort"
//#pragma link "OoMisc"
#pragma link "AdPort"
#pragma link "OoMisc"
#pragma resource "*.dfm"
TfrmMain *frmMain;
//---------------------------------------------------------------------------
__fastcall TfrmMain::TfrmMain(TComponent* Owner)
   : TForm(Owner)
{
}
//---------------------------------------------------------------------------

//------------------------------------------------------------------------------
//  
//------------------------------------------------------------------------------
void __fastcall TfrmMain::FormCreate(TObject *Sender)
{
//
  //  -     
   MainCam = new TXiCamVVRK1();


   FillComPortsList();     //   -
   ComCamConnect = new TXiCamVVRK1_CnctnCOM(MainComPort);   //    COM


   MainCam->Connection = ComCamConnect;

  //  
   MainCam->OnResponseWait = ResponseCapture;

   MainCam->OnCapture = CamCapture;

}
//---------------------------------------------------------------------------

//------------------------------------------------------------------------------
//   ()
//------------------------------------------------------------------------------
void __fastcall TfrmMain::FormDestroy(TObject *Sender)
{

   delete ComCamConnect;
   delete MainCam;
}
//---------------------------------------------------------------------------

//------------------------------------------------------------------------------
//       
//------------------------------------------------------------------------------
void __fastcall TfrmMain::btnCaptureClick(TObject *Sender)
{


  //  ""
   InitCaptureInds();

  //  
   PanelSnap->Color = clBlue;
   PanelSnap->Repaint();


   TMemoryStream* pms = new TMemoryStream();    //    
   AnsiString JpgFileName = ExtractFilePath(Application->ExeName) + "dump.jpg";

   try
   {
      MainCam->Capture(pms);                    //    
      pms->Position = 0;                        //    !


      TJPEGImage* jp = new TJPEGImage();
      try
      {
         jp->LoadFromStream(pms);               //  -> JPEG

         if(ChBoxSaveDump->Checked)             // .   
            jp->SaveToFile(JpgFileName);

         if(!jp->Empty && pms->Size)    //  . ... 
            ImgSnap->Picture->Assign(jp);

         edtReceived->Text = pms->Size;

      }
      __finally
      {
         delete jp;         // -  JPEG
      }

   }
   __finally
   {
      delete pms;           // -   
   }

   PanelSnap->Color = clGray;    // 
}
//---------------------------------------------------------------------------

//------------------------------------------------------------------------------
//   
//------------------------------------------------------------------------------
void __fastcall TfrmMain::ChBoxColouredClick(TObject *Sender)
{
   MainCam->Coloured = ChBoxColoured->Checked;
}
//---------------------------------------------------------------------------

//------------------------------------------------------------------------------
//    
//------------------------------------------------------------------------------
void __fastcall TfrmMain::CmbBoxAspectChange(TObject *Sender)
{
   MainCam->AspectRatio = CmbBoxAspect->ItemIndex;
}
//---------------------------------------------------------------------------

//------------------------------------------------------------------------------
//      ()
//------------------------------------------------------------------------------
void __fastcall TfrmMain::btnFrameSizeClick(TObject *Sender)
{
   MainCam->SizeH = edtFrameW->Text.ToInt();
   edtFrameW->Text = MainCam->SizeH;

   MainCam->SizeV = edtFrameH->Text.ToInt();
   edtFrameH->Text = MainCam->SizeV;
}
//---------------------------------------------------------------------------

//------------------------------------------------------------------------------
//       
//------------------------------------------------------------------------------
void __fastcall TfrmMain::InitContols()
{
   //
   ChBoxColoured->Checked = MainCam->Coloured;
   CmbBoxAspect->ItemIndex = MainCam->AspectRatio;

  //  
   edtFrameW->Text = MainCam->SizeH;
   edtFrameH->Text = MainCam->SizeV;

   ChBox_TestMode->Checked = MainCam->TestMode;
}

//------------------------------------------------------------------------------
//     
//------------------------------------------------------------------------------
void __fastcall TfrmMain::ChBox_TestModeClick(TObject *Sender)
{
   MainCam->TestMode = ChBox_TestMode->Checked;
}
//---------------------------------------------------------------------------

//------------------------------------------------------------------------------
//  ,     ( 
//  
//------------------------------------------------------------------------------
void __fastcall TfrmMain::ResponseCapture(TObject *Sender)
{
//
   Application->ProcessMessages();     //  ,  
}
//---------------------------------------------------------------------------

//------------------------------------------------------------------------------
//  ,     ()
//------------------------------------------------------------------------------
void __fastcall TfrmMain::CamCapture(TObject *Sender, __int64 BytesWrote)
{

   if(BytesWrote < 699)
      PanIndDataNotFound->Color = clRed;     //    ( )
   else
   {
      if(BytesWrote == 699)
         PanIndHeaderOnly->Color = clRed;    //  
      else
         PanIndCapturedOK->Color = clLime;   //  
   }

}
//---------------------------------------------------------------------------


//------------------------------------------------------------------------------
//   :    
//------------------------------------------------------------------------------
void __fastcall TfrmMain::btnCaptureSleepClick(TObject *Sender)
{
//
   MainCam->SleepTime = edtCaptureSleep->Text.ToInt();
}
//---------------------------------------------------------------------------

//------------------------------------------------------------------------------
//  "" "  "
//------------------------------------------------------------------------------
void __fastcall TfrmMain::InitCaptureInds()
{
   PanIndCapturedOK->Color = clGreen;
   PanIndDataNotFound->Color = clMaroon;
   PanIndHeaderOnly->Color = clMaroon;
}

//------------------------------------------------------------------------------
//    -
//------------------------------------------------------------------------------
void __fastcall TfrmMain::FillComPortsList()
{
   for (int i=1; i<=2; ++i)      //     
      if(IsPortAvailable(i))
         CmbBox_ComPortsList->Items->Add(ComName(i));

   if(CmbBox_ComPortsList->Items->Count)
      CmbBox_ComPortsList->ItemIndex = 0;

}

//------------------------------------------------------------------------------
//   ( )
//------------------------------------------------------------------------------
void __fastcall TfrmMain::MainComPortPortOpen(TObject *Sender)
{
   btnComConnect->Caption = "";
   //StatLConnected->Lit = true;
   PanComStatConnection->Color = clLime;

   MainComPort->FlushInBuffer();    //  
   MainComPort->FlushOutBuffer();

   InitContols();

}
//---------------------------------------------------------------------------

//------------------------------------------------------------------------------
//   ( )
//------------------------------------------------------------------------------
void __fastcall TfrmMain::MainComPortPortClose(TObject *Sender)
{
   btnComConnect->Caption = "";
   //StatLConnected->Lit = false;
   PanComStatConnection->Color = clGreen;

}
//---------------------------------------------------------------------------

//------------------------------------------------------------------------------
//    COM-
//------------------------------------------------------------------------------
void __fastcall TfrmMain::btnComConnectClick(TObject *Sender)
{
   if(ComCamConnect->Active)
      ComCamConnect->Active = false;   //  
   else
   {
      if(CmbBox_ComPortsList->ItemIndex == -1)
         return;                       //   -
      MainComPort->ComNumber = CmbBox_ComPortsList->ItemIndex + 1;
      CmbBox_BaudRateChange(NULL);    // . 
      ComCamConnect->Active = true;   //  
   }

}
//---------------------------------------------------------------------------

//------------------------------------------------------------------------------
//    
//------------------------------------------------------------------------------
void __fastcall TfrmMain::ChBox_CapturingClick(TObject *Sender)
{
  //    (     )
   while(ChBox_Capturing->Checked)
      btnCaptureClick(NULL);


}
//---------------------------------------------------------------------------

//------------------------------------------------------------------------------
//     
//------------------------------------------------------------------------------
void __fastcall TfrmMain::CmbBox_BaudRateChange(TObject *Sender)
{
//
   MainCam->UART = CmbBox_BaudRate->ItemIndex + 1;
   MainComPort->Baud = CmbBox_BaudRate->Text.ToInt();
}
//---------------------------------------------------------------------------

